import React from 'react';
import WindowsLogo from "./windows";
import MacOSLogo from "./macos";
import LinuxLogo from "./linux";
import AndroidLogo from "./android";
import BashTabs from "../BashTabs";
import { jsx as ___EmotionJSX } from "@emotion/react";
var BashOSPlatform = function BashOSPlatform(props) {
  var windows = props.windows,
    linux = props.linux,
    macos = props.macos,
    ios = props.ios,
    android = props.android,
    _props$defaultActiveK = props.defaultActiveKey,
    defaultActiveKey = _props$defaultActiveK === void 0 ? 'windows' : _props$defaultActiveK;
  var tabItems = React.useMemo(function () {
    return [{
      key: 'windows',
      children: windows,
      iconRender: WindowsLogo,
      label: 'windows'
    }, {
      key: 'linux',
      children: linux,
      iconRender: LinuxLogo,
      label: 'linux'
    }, {
      key: 'macos',
      children: macos,
      iconRender: MacOSLogo,
      label: 'macos'
    }, {
      key: 'ios',
      children: ios,
      iconRender: MacOSLogo,
      label: 'ios'
    }, {
      key: 'android',
      children: android,
      iconRender: AndroidLogo,
      label: 'android'
    }].filter(function (item) {
      return item.children;
    });
  }, [windows, linux, macos, ios, android]);
  return ___EmotionJSX(BashTabs, {
    tabItems: tabItems,
    defaultActiveKey: defaultActiveKey
  });
};
export default BashOSPlatform;