import React from 'react';
import NpmLogo from "./npm";
import PnpmLogo from "./pnpm";
import YarnLogo from "./yarn";
import BashTabs from "../BashTabs";
import { jsx as ___EmotionJSX } from "@emotion/react";
var InstallDependencies = function InstallDependencies(props) {
  var npm = props.npm,
    yarn = props.yarn,
    pnpm = props.pnpm,
    _props$defaultActiveK = props.defaultActiveKey,
    defaultActiveKey = _props$defaultActiveK === void 0 ? 'npm' : _props$defaultActiveK;
  var tabItems = React.useMemo(function () {
    return [{
      key: 'npm',
      children: npm,
      iconRender: NpmLogo,
      label: 'npm'
    }, {
      key: 'yarn',
      children: yarn,
      iconRender: YarnLogo,
      label: 'yarn'
    }, {
      key: 'pnpm',
      children: pnpm,
      iconRender: PnpmLogo,
      label: 'pnpm'
    }].filter(function (item) {
      return item.children;
    });
  }, [npm, yarn, pnpm]);
  return ___EmotionJSX(BashTabs, {
    tabItems: tabItems,
    defaultActiveKey: defaultActiveKey
  });
};
export default InstallDependencies;