import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { Helmet, useRouteMeta } from 'dumi';
import { useMemo } from 'react';
import useLocaleValue from "../hooks/useLocaleValue";
import { removeTitleCode } from "../utils";
import { jsx as ___EmotionJSX } from "@emotion/react";
var CommonHelmet = function CommonHelmet() {
  var meta = useRouteMeta();
  var configTitle = useLocaleValue('title');
  var _useMemo = useMemo(function () {
      var _meta$frontmatter;
      var helmetTitle = "".concat(removeTitleCode(meta.frontmatter.subtitle) || '', " ").concat(removeTitleCode((_meta$frontmatter = meta.frontmatter) === null || _meta$frontmatter === void 0 ? void 0 : _meta$frontmatter.title), " - ").concat(configTitle);
      var helmetDescription = meta.frontmatter.description;
      return [helmetTitle, helmetDescription];
    }, [meta, configTitle]),
    _useMemo2 = _slicedToArray(_useMemo, 2),
    title = _useMemo2[0],
    description = _useMemo2[1];
  return ___EmotionJSX(Helmet, null, ___EmotionJSX("title", null, title), ___EmotionJSX("meta", {
    property: "og:title",
    content: title
  }), description && ___EmotionJSX("meta", {
    name: "description",
    content: description
  }));
};
export default CommonHelmet;