var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/plugin.ts
var plugin_exports = {};
__export(plugin_exports, {
  default: () => plugin_default,
  getHash: () => getHash
});
module.exports = __toCommonJS(plugin_exports);
var import_fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
var import_crypto = require("crypto");
var import_create_instance = __toESM(require("@emotion/server/create-instance"));
var import_css = require("@emotion/css");
function extractEmotionStyle(html) {
  if (html === void 0) {
    throw new Error("did you forget to return html from renderToString?");
  }
  const { extractCritical } = (0, import_create_instance.default)(import_css.cache);
  const { ids, css } = extractCritical(html);
  if (!css)
    return [];
  return [
    {
      key: import_css.cache.key,
      ids,
      css,
      tag: `<style data-emotion="${import_css.cache.key} ${ids.join(" ")}">${css}</style>`
    }
  ];
}
var getHash = (str, length = 8) => (0, import_crypto.createHash)("md5").update(str).digest("hex").slice(0, length);
var dumiThemeUmiPlugin = (api) => {
  const writeCSSFile = (key, hashKey, cssString) => {
    const fileName = `style-${key}.${getHash(hashKey)}.css`;
    const filePath = import_path.default.join(api.paths.absOutputPath, fileName);
    if (!import_fs.default.existsSync(filePath)) {
      import_fs.default.writeFileSync(filePath, cssString, "utf8");
    }
    return fileName;
  };
  const addLinkStyle = (html, cssFile, prepend = false) => {
    const prefix = api.userConfig.publicPath || api.config.publicPath;
    if (prepend) {
      return html.replace("<head>", `<head><link rel="stylesheet" href="${prefix + cssFile}">`);
    }
    return html.replace("</head>", `<link rel="stylesheet" href="${prefix + cssFile}"></head>`);
  };
  api.modifyConfig((memo) => {
    memo.themeConfig.ssr = memo.ssr;
    return memo;
  });
  api.modifyExportHTMLFiles((files) => {
    var _a;
    if ((_a = api.config) == null ? void 0 : _a.ssr) {
      const nextFiles = files.filter((f) => !f.path.includes(":")).map((file) => {
        let globalStyles = "";
        file.content = file.content.replace(
          /<style (data-emotion|data-sandpack)[\S\s]+?<\/style>/g,
          (s) => {
            globalStyles += s;
            return "";
          }
        );
        file.content = file.content.replace("</head>", `${globalStyles}</head>`);
        const styles = extractEmotionStyle(file.content);
        styles.forEach((result) => {
          const cssFile2 = writeCSSFile(result.key, result.ids.join(""), result.css);
          file.content = addLinkStyle(file.content, cssFile2);
        });
        const matchRegex = /<style data-type="antd-cssinjs">(.*?)<\/style>/;
        const matchList = file.content.match(matchRegex) || [];
        let antdStyle = "";
        matchList.forEach((text) => {
          file.content = file.content.replace(text, "");
          antdStyle += text.replace(matchRegex, "$1");
        });
        const cssFile = writeCSSFile("antd", antdStyle, antdStyle);
        file.content = addLinkStyle(file.content, cssFile, true);
        return file;
      });
      return nextFiles;
    }
    return files;
  });
};
var plugin_default = dumiThemeUmiPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getHash
});
