import { DownOutlined } from '@ant-design/icons';
import { Button, Dropdown } from 'antd';
import { FormattedMessage } from 'dumi';
import React from 'react';
import useLocaleValue from "../../hooks/useLocaleValue";
import { jsx as ___EmotionJSX } from "@emotion/react";
export var getMoreLinksGroup = function getMoreLinksGroup(moreLinks) {
  return (moreLinks !== null && moreLinks !== void 0 ? moreLinks : []).map(function (item, index) {
    return {
      label: ___EmotionJSX("a", {
        href: item.link,
        target: "_blank",
        rel: "noopener noreferrer"
      }, item.text),
      key: index
    };
  });
};
var More = function More() {
  var moreLinks = useLocaleValue('moreLinks') || [];
  return Array.isArray(moreLinks) && moreLinks.length > 0 ? ___EmotionJSX(Dropdown, {
    menu: {
      items: getMoreLinksGroup(moreLinks)
    },
    placement: "bottomRight"
  }, ___EmotionJSX(Button, {
    size: "small"
  }, ___EmotionJSX(FormattedMessage, {
    id: "app.header.menu.more"
  }), ___EmotionJSX(DownOutlined, null))) : null;
};
export default More;